"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const get_reg_core_1 = __importDefault(require("../get-reg-core"));
function publish(options) {
    const core = (0, get_reg_core_1.default)(options);
    const processor = core.createProcessor();
    const resultPath = path_1.default.join(core.getDirectoryInfo().workingDirs.base, "out.json");
    let comparisonResult;
    try {
        comparisonResult = JSON.parse(fs_1.default.readFileSync(resultPath, "utf8"));
    }
    catch (e) {
        core.logger.error(`Not found comparison result file. Retry after execution ${core.logger.colors.cyan("reg-suit compare")}.`);
        return Promise.reject(e);
    }
    return processor
        .getExpectedKey()
        .then(ctx => processor.getActualKey({
        comparisonResult,
        expectedKey: ctx.expectedKey,
    }))
        .then(ctx => processor.publish(ctx))
        .then(ctx => (options.notification ? processor.notify(ctx) : ctx))
        .then(() => null);
}
exports.default = publish;
//# sourceMappingURL=publish.js.map