"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const reg_suit_core_1 = require("reg-suit-core");
const package_util_1 = __importDefault(require("./package-util"));
let _coreInstanceForCache;
function getRegCore(options, ignoreCache = false) {
    const localCoreModuleId = options.noInstallCore ? null : package_util_1.default.checkInstalledLocalCore();
    let core;
    if (!ignoreCache && _coreInstanceForCache) {
        return _coreInstanceForCache;
    }
    if (localCoreModuleId) {
        // use local installed reg-suit-core if user project has it.
        const CoreFactory = require(localCoreModuleId)["RegSuitCore"];
        core = new CoreFactory({
            logLevel: options.logLevel,
            noEmit: options.noEmit,
            configFileName: options.configFileName,
        });
    }
    else {
        core = new reg_suit_core_1.RegSuitCore({
            logLevel: options.logLevel,
            noEmit: options.noEmit,
            configFileName: options.configFileName,
        });
    }
    _coreInstanceForCache = core;
    return _coreInstanceForCache;
}
exports.default = getRegCore;
//# sourceMappingURL=get-reg-core.js.map